<?php
/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

require_once('inc/config.php');
require_once('inc/security.php');
require_once('inc/functions.php');
require_once('inc/cl_db.php');
require_once('inc/cl_user.php');
require_once('inc/cl_feed.php');
require_once('inc/cl_feedlink.php');

$DEBUG = 0;
//error_reporting(E_ALL);

// Only allow authorized access to this script
if (($UID = getUidFromCookie()) != NULL ||
    ($UID = getDefaultUid()) != NULL)
{
  if (isset($_GET['op']))
  {
    $db = new DB();
    $db->open() or die ("Unable to connect to database.");
    $user = new user ($db, $UID);
    if (!$user->valid || $user->disabled) die ("Bad User.");

    switch ($_GET['op']) {

      case 'markfeed':
        if (isset($_GET['id']) && is_numeric($_GET['id'])) {

          noCache();

          feedlink::mark ($db, $user->userid, $_GET['id']);
          echo "ack|Feed marked read.";
        }
        break;

      case 'expand':
        if (isset($_GET['id']) && isset($_GET['fid'])) {

          $id = intval(substr($_GET['id'],1));
          $feedid = intval($_GET['fid']);
          $sql = 'SELECT description FROM '. DB_PREFIX.$user->userid ."_links WHERE id='$id'";
          $result = $db->query($sql);

          if ($result && ($myrow = mysql_fetch_array($result))) {
            $desc = $myrow['description'];
            if (strlen($desc) == 0)
              $desc = 'No more information available.';
            echo "expand|L$id|$desc";
          } else {
            echo "expand|L$id|". $db->error();
          }

          // Client returns feedid -1 after an expand + collapse + expand 
          // operation, so we count only first expansion (per page load)
          if ($user->keep_stats && $feedid > 0)
            feed::inc_stat ($db, $user->userid, $feedid, 'expand');
        }
        break;

      case 'more':
        if (isset($_GET['id']) && isset($_GET['n'])) {

          noCache();

          $id = intval($_GET['id']); // feed id
          $n = intval($_GET['n']);   // index of next article
          $feed = new feed ($db, $id, $user->userid);

          if ($feed->valid) {

            list ($str, $strnum, $more, $moreseen) =
              ajaxLinkStr ($db, $user, $id, $n, $feed->headlines, FALSE);

            echo "more|$id|";
            if ($more)
              echo morelinkHTML ($id, $n + $strnum, $moreseen);
            echo "$str|";
            }
        }
        break;

      case 'update':
      case 'refresh':
        if (isset($_GET['id'])) {

          noCache();

          $id = intval($_GET['id']);
          $feed = new feed ($db, $id, $user->userid);
          if ($feed->valid) {

            if ($_GET['op'] == 'update')
              forceUpdate ($db, $user->userid, $feed);

            require_once('inc/rss.php');
            require_once('magpierss/rss_fetch.inc');
            require_once('magpierss/rss_utils.inc');

            list($err,$warn) = readRssFeed ($db, $user, $feed);  // Load new articles if needed
            list ($str, $strnum, $more, $moreseen) =
              ajaxLinkStr ($db, $user, $id, 0, $feed->headlines, TRUE);

            if ($str == '')
              $str = '|none'.$feed->id.'|<span class="seen">&mdash; No new articles available.</span>';

            echo "refresh|$id|$err|$warn|". feedinfoHTML ($feed, $user->keep_stats) ."|$id|";
            if ($more)
              echo morelinkHTML ($id, $strnum, $moreseen);
            echo "$str|";
          }
        }
        break;

      default:
        echo 'loser';
        break;
    }
  }
}
?>
