<?php

require_once('rss.php');

// -------------------------------------------------------------------------------
function outputHeader ($user = NULL, $t = NULL, $status = NULL, $onload = NULL, $meta = NULL, $js = NULL) {

  $title = defined('RNEWS_TITLE') ? RNEWS_TITLE : '';
  if (!empty($t)) { $title .= ": $t"; }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<?php if ($meta) echo $meta ?>
    <link rel="shortcut icon" href="favicon.ico" />
    <link rel="stylesheet" href="rnews-side.css" type="text/css" />
<!--[if IE 6]>
    <link rel="stylesheet" href="rnews-ie6.css" type="text/css" />
<![endif]-->
    <script type="text/javascript" src="ajax.js"></script>
    <script type="text/javascript" src="functions.js"></script>
    <script type="text/javascript" src="rollover.js"></script>
<?php if ($js): ?>
    <script type="text/javascript">
      <!--
<?php echo $js ?>
      // -->
    </script>
<?php endif; ?>
    <title><?php echo 'Rnews '.$title ?></title>
  </head>
  <body<?php if ($onload) echo " onload=\"$onload\"" ?>>
  <div id="container">
  <div id="header">
    <a href="index.php"><img id="logo" src="img/rnews-logo.png" alt="Rnews" /></a>
<?php
  echo '<h1><a href="index.php">'.
    (defined('RNEWS_TITLE') ? RNEWS_TITLE : 'Feed Aggregator') .'</a></h1>';
?>
    <?php outputUserActions($user) ?>
    <?php if ($user !== NULL) outputSearchBox() ?>
    <div id="status"><?php echo $status ? $status : '&nbsp;' ?></div>
  </div>
<?php

}

// -------------------------------------------------------------------------------
function outputUserActions(&$user) {
  echo '<div class="actions">';
  if ($user !== NULL && !$user->restricted) {
    echo htmlspecialchars($user->name) .': ';
    echo '<a href="prefs.php">Preferences</a>&nbsp;|&nbsp; ';
    echo '<a href="auth.php?logout=1">Log Out</a>';
  } else {
    echo '<a href="auth.php">Log In</a>';
  }
  echo '</div>';
}

// -------------------------------------------------------------------------------
function outputSearchBox() {
?>
  <div id="search">
    <form action="search.php" method="post">
      <input type="text" name="q" size="12" maxlength="30" tabindex="1" class="text" />
      <input type="submit" name="search" value="Search" tabindex="2" class="button" />
    </form>
    <span><a href="search.php">Advanced</a></span>
  </div>
<?php
}

// -------------------------------------------------------------------------------
// This provides category links in the header
//
function outputNavigation (&$db, &$user, $selCatId = 0) {

  echo '<div id="navigation"><ul>';
  echo '<li><a href="index.php?all=1"><em>All Sources</em></a></li>';

	foreach (category::all($db, $user->userid, 'ORDER BY name') as $cat) {
		echo '<li'. (($selCatId && ($selCatId == $cat->id)) ? ' class="selected"' : '')
			.'><a href="index.php?category='. $cat->id .'">'. htmlspecialchars($cat->name) .'</a></li>';
	}

  echo '</ul></div>' . "\n";
}

// -------------------------------------------------------------------------------
function outputCatHead (&$user, &$cat, $args, $viewSort) {
  echo "\n<div class=\"category\">\n";
  echo '<div class="categoryHead clearfix">';
  echo "<h2><a href=\"index.php?category=$cat->id\">". htmlspecialchars($cat->name) ."</a></h2>\n";

  echo '<div class="actions">';

  if ($viewSort) {
    $a2 = $args;
    $a2['category'] = $cat->id;
    echo sortlinkHTML ($user->keep_stats, $user->prefs, $a2);
    echo viewlinkHTML ($user->prefs, $a2);
  }

  if (!$user->restricted) {
    // Delete
    echo '<a href="prefs.php?deleteCat=y"><img src="img/b2-x_nm.png" alt="delete category" title="delete category" /></a>';

    // Edit
    echo '<a href="add.php?editCat='. $cat->id .'"><img src="img/b2-edit_nm.png" alt="edit category" title="edit category" /></a> &nbsp;&nbsp;';
 
    // Add
    echo '<a href="add.php'. argsToUrl(array('new'=>'y','category'=>$cat->id)) .'"><img src="img/b1-add_nm.png" alt="add a feed" title="add a feed" /></a>';
  }

  // Mark
  unset($args['q']);
  unset($args['contents']);
  $args['seen'] = 'cat';
  $args['category'] = $cat->id;
  echo '<a href="index.php'. argsToUrl($args) .'">';
  echo '<img src="img/b1-markall_nm.png" alt="mark category" title="mark category as read" /></a>';
  echo "</div></div>\n";
}

// -------------------------------------------------------------------------------
// Output feed header
// -------------------------------------------------------------------------------
function outputFeedhead(&$user, &$feed, $getArgs)
{
  unset($getArgs['q']);
  unset($getArgs['contents']);

  echo '<div class="feedhead clearfix">' . "\n" .
    '<div class="feedtitle">' .
    '<a href="' . $feed->main_link . '">';

  if ($user->show_images) {
    $image = empty($feed->image_link) ? DEFAULT_IMAGE : $feed->image_link;
    echo '<img src="' . $image . '" alt="' . htmlspecialchars($feed->name)
      . '" title="' . htmlspecialchars($feed->name) .'" /></a><a href="'
      . $feed->main_link .'">';
  }
  echo htmlspecialchars($feed->name) . '</a></div>';
  echo '<div class="actions">';

  if (!$user->restricted) {
    // Delete
    echo '<a href="prefs.php?delete_feed=' . $feed->id . '"><img src="img/b2-x_nm.png" alt="delete" title="delete feed" /></a>';

    // Edit
    echo '<a href="add.php?edit=' . $feed->id . '"><img src="img/b2-edit_nm.png" alt="edit" title="edit feed" /></a>';

    // Force update
    $updArgs = $getArgs;
    $updArgs['update'] = $feed->id;
    unset($updArgs['seen']);
    echo '<a href="index.php'. argsToUrl($updArgs) .'" title="force update of feed"'
      . 'onclick="update(\''.$feed->id.'\');return false;">';
    echo '<img src="img/b2-update_nm.png" alt="update" title="force update of feed" /></a>&nbsp;&nbsp;';
  }

  // Mark
  $getArgs['seen'] = $feed->id;
  echo '<a href="index.php'. argsToUrl($getArgs);
  echo '" onclick="markfeed(\''.$feed->id.'\');return false;" title="mark feed as read">';
  echo '<img src="img/b2-mark_nm.png" alt="mark" title="mark feed as read" /></a>';

  echo '</div>';
  echo "</div>\n "; // feedhead
}

//----------------------------------------------------------------------------
function outputOneFeed (&$db, &$user, &$feed, $getArgs)
{
  echo "<div id=\"wrapper\"><div id=\"content\">\n";
  echo checkInsecureFilePerms();
  echo '<div class="feedwide">';
  outputFeedhead ($user, $feed, $getArgs);

  // Update the RSS links, if it's time.
  list($err, $warn) = readRssFeed ($db, $user, $feed);
  if ($err != '')
    echo '<p class="error">'.$err.'</p>';
  if ($warn != '')
    echo '<p class="warn">'.$warn.'</p>';

  echo '<div id="feed'. $feed->id .'" class="feedcontent clearfix"><dl>';

  $filter = 'WHERE feed_id=\''. $feed->id .'\' ORDER BY id DESC';
  if ($user->max_links > 0)
    $filter .= ' LIMIT '. $user->max_links;

  foreach (feedlink::all($db, $user->userid, $filter) as $link) {
    if ($user->expand_one) {
      echo '<dt><a href="redirect.php?redirect_link=' . urlencode($link->link) . '&amp;id=' . $feed->id . '&amp;artid=' . $link->id . '" class="' . feedlink::stateStr($link->state) . '">' . $link->title . "</a></dt>\n";
      echo '<dd>'. $link->description ."</dd>\n";
    } else {
      echo '<dt id="L'. $link->id .'" class="feedlink">'.
        feedlinkHTML ($feed->id, $link, $user->new_window). "</dt>\n";
    }
  }

  echo '</dl><p id="info'.$feed->id.'" class="info">'
    . feedInfoHTML ($feed, $user->keep_stats) .'</p></div>';
  echo "</div></div></div>\n"; // feed, container, wrapper
}

//----------------------------------------------------------------------------
// This is quite complicated because it handles:
//  - printing all or a single category
//  - printing block, wide-block, and list views
//  - printing search results
//  - allowing async update after page has loaded
//
function outputFeeds (&$db, &$user, &$category, $getArgs, $search = NULL)
{
  $blockView = !isset($user->prefs['V']) || $user->prefs['V'] != 'L'; // either B or W
  $blockViewWide = isset($user->prefs['V']) && $user->prefs['V'] == 'W'; // only W

  echo "<div id=\"wrapper\"><div id=\"content\">\n";
  echo checkInsecureFilePerms();

  $cat = NULL;
  $numInPair = 0;       // detect feedpairs
  $someShown = FALSE;   // for list view 'none' msg

  $emptyStr = $search ? 'No articles matched.' : 'No new articles available.';
  $flushOut = (!$search && (!AJAX_LOAD || !$blockView));

  $filter = $category ? " WHERE cat_id='$category->id'" : '';
  $filter .= ' ORDER BY cat_id';
  if ($user->keep_stats &&
      (!isset($user->prefs['S']) || $user->prefs['S'] == 'S'))
    $filter .= ', (stat_expand+stat_click)/stat_total DESC';
  $filter .= ', name';

  $feeds = feed::all($db, $user->userid, $filter);

  if (count($feeds) > 0) {

    if ($flushOut) { @ob_flush(); @flush(); }  // Give feedback to the user

    foreach ($feeds as $feed)
    {
      // Detect change of category, output new div to contain it
      if (!$cat || $feed->cat_id != $cat->id) {
        $firstCat = ($cat == NULL);
        $cat = new category ($db, $feed->cat_id, $user->userid);
        if (!$cat->valid)
          $cat = new category();

        if ($blockView && !$blockViewWide) {
          // Finish off the feedpair if it hasn't been closed yet
          if ($numInPair == 1) { echo "</div>\n"; }
          $numInPair = 0;
        }
        if (!$firstCat) {
          if (!$blockView)
            echo '</dl></div></div></div>'; //dl,feedcontent,feedwide,div
          echo '</div>'; //category
        }

        outputCatHead ($user, $cat, $getArgs, $firstCat);

        if (!$blockView) {
          echo '<div class="clearfix">';
          echo '<div class="feedwide">';
          echo '<div class="feedcontent clearfix">';
          echo '<dl>';
        }
      }

      if ($blockViewWide) {
        echo '<div class="clearfix"><div class="feedwide">';
      } else if ($blockView) {
        if ($numInPair == 0)
          echo '<div class="feedpair clearfix">';   // start new pair of blocks
        echo '<div class="feed">';
      }

      // start the individual feed
      if ($blockView)
        outputFeedhead ($user, $feed, $getArgs);

      $loadAsync = (AJAX_LOAD && $blockView && !$search && updateRssFeed ($user, $feed));

      if (!$search && !$loadAsync) {
        list($err,$warn) = readRssFeed ($db, $user, $feed); // Update the RSS links, if it's time.
        if ($err != '')
          echo '<p class="error">'.$err.'</p>';
        if ($warn != '')
          echo '<p class="warn">'.$warn.'</p>';
      }

      if ($loadAsync) {
        $links = array();   // dont show any articles now, will load async
      } else {
        // Only simple keyword type search is supported currently
        if ($search)
          $filter = "WHERE feed_id='". $feed->id ."' AND $search ORDER BY id DESC";
        else
          $filter = "WHERE feed_id='". $feed->id ."' ORDER BY id DESC LIMIT ". ($feed->headlines + 1);

        $links = feedlink::all ($db, $user->userid, $filter);
      }

      if ($blockView) {
        echo '<div id="feed'.$feed->id.'" class="feedcontent clearfix">';
        if (!$blockViewWide)
          echo '<div class="wide"><a href="#" onclick="gowide('.$feed->id.');return false" title="make full width"><img src="img/morew_nm.png" /></a></div>';
        echo '<dl>';
      }

      $nunread = 0;
      $moreseen = TRUE;
      $moreexists = FALSE;
      foreach ($links as $link)
      {
        // Show only new articles unless searching; allow for n+1 in sql above
        if (!$search &&
            ($link->state != feedlink::STATE_NEW() || $nunread == $feed->headlines))
          break;

        $nunread++;
        echo '<dt id="L'. $link->id .'" class="feedlink">'
          . feedlinkHTML ($feed->id, $link, $user->new_window,
            ($blockView ? NULL : $feed->name)) ."</dt>\n";
      }

      if ($blockView) {
        if ($nunread == 0) {
          if ($loadAsync) {
            echo "<script type=\"text/javascript\">initFeed({$feed->id});</script>";
            echo '<dt id="none'. $feed->id. '" class="loading">&mdash; Loading articles...</dt>';
          } else {
            echo '<dt id="none'. $feed->id. '" class="seen">&mdash; '. $emptyStr .'</dt>';
          }
        }

        if (!$search) {
          if ($nunread < count($links)) {
            // Peek ahead at the next link (if one) to see its state
            $moreseen = ($links[$nunread]->state != feedlink::STATE_NEW());
            echo '<dt id="more'. $feed->id .'" class="more">';
            echo morelinkHTML($feed->id, $nunread, $moreseen) .'</dt>';
          } else {
            echo '<dt id="more'. $feed->id .'" class="more"></dt>';
          }
        }

        echo '</dl>';
        echo '<p class="all"><a href="index.php?more=' . $feed->id . '" title="see all articles in this feed" class="seen">see all...</a></p>';

        echo '<p id="info'.$feed->id.'" class="info">'
          . feedInfoHTML ($feed, $user->keep_stats) .'</p>';

        echo "</div>\n</div>\n"; //feedcontent,feed/wide

        $numInPair++;
        if ($blockViewWide || $numInPair == 2) {
          echo "</div>\n";  //feedpair or clearfix(wide)
          $numInPair = 0;
        }
      }

      if ($nunread > 0)
        $someShown = TRUE; // for list view

      if ($flushOut) { @ob_flush(); @flush(); }  // Give feedback to the user

    } //foreach feed

    if ($blockView) {
      if ($numInPair == 1 || $blockViewWide)
        echo "</div></div>\n"; //feedpair or plain clearfix
    } else {
      if (!$someShown)
        echo '<dt id="none'. $feed->id. '" class="seen">&mdash; '.$emptyStr.'</dt>';
      echo '</dl></div></div></div>'; //dl,feedcontent,feedwide,div
    }

    echo '</div>'; //category
  } else {
    if ($category) {
      echo '<div class="clearfix"><div class="feedwide"><div class="feedcontent clearfix">';
      outputCatHead ($user, $category, $getArgs, FALSE);
    }
    echo '<div class="feed"><p><a href="add.php?new=y'. ($category ? "&amp;category=$category->id" : '') .'">Add a feed</a> to get started!</p></div>';
    if ($category)
      echo '</div></div></div>';
  }

  echo '</div></div>'; //content,wrapper
}

